Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_kernel_impl.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_kernel_impl.c	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_kernel_impl.c	(revision 374)
@@ -53,5 +53,9 @@
 #include "syssvc/serial.h"
 #ifdef TOPPERS_OMIT_TECS
-#include "rx630_uart.h"
+#include "serial_api.h"
+#endif
+
+#ifdef TOPPERS_OMIT_TECS
+serial_t log_serial;
 #endif
 
@@ -78,18 +82,12 @@
 		sil_reb_mem(PORTA_PDR_ADDR) & ~PORT_PDR_B7_BIT);
 
+#ifdef TOPPERS_OMIT_TECS
 	/*
 	 *  シリアルポートの設定
 	 */
-
-	/* ポートP20をTxD0, ポートP21をRxD0に */
-	sil_wrb_mem(PORT2_PMR_ADDR, 0x03);
-
-	/* データディレクションレジスタ(PDR)の設定 P21(RxD0)を入力ポートにする */
-	sil_wrb_mem(PORT2_PDR_ADDR, 
-		sil_reb_mem(PORT2_PDR_ADDR) & ~PORT_PDR_B1_BIT);
-
-	/* データディレクションレジスタ(PDR)の設定 P20(TxD0)を出力ポートにする */
-	sil_wrb_mem(PORT2_PDR_ADDR, 
-		sil_reb_mem(PORT2_PDR_ADDR) | PORT_PDR_B0_BIT);
+	serial_init(&log_serial, P20, P21);
+	serial_baud(&log_serial, UART_BAUDRATE);
+	serial_format(&log_serial, 8, ParityNone, 1);
+#endif
 
 	/* ポートP40～P47を周辺機器に */
@@ -152,8 +150,8 @@
 {
 	if (c == '\n') {
-		rx630_uart_pol_putc('\r', TARGET_PUTC_PORTID);
+		serial_putc(&log_serial, '\r');
 	}
 
-	rx630_uart_pol_putc(c, TARGET_PUTC_PORTID);
+	serial_putc(&log_serial, c);
 }
 #endif
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.c	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.c	(revision 374)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems/
  *      Advanced Standard Profile Kernel
- * 
+ *
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
@@ -12,5 +12,5 @@
  *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
  *  Copyright (C) 2013      by Mitsuhiro Matsuura
- * 
+ *
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -35,5 +35,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- * 
+ *
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -41,5 +41,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- * 
+ *
  *  @(#) $Id$
  */
@@ -51,4 +51,62 @@
 #include <sil.h>
 #include "target_serial.h"
+#include "hal/serial_api.h"
+#include "target_syssvc.h"
+#include "syssvc/serial.h"
+
+/*
+ *  シリアルI/Oポート初期化ブロックの定義
+ */
+typedef struct sio_port_initialization_block {
+	PinName tx;
+	PinName rx;
+} SIOPINIB;
+
+/*
+ *  シリアルI/Oポート管理ブロックの定義
+ */
+struct sio_port_control_block {
+	const SIOPINIB *p_siopinib;
+	intptr_t exinf;
+	bool_t openflag;
+	serial_t serial;
+};
+
+/*
+ *  シリアルI/Oポート管理ブロックのエリア
+ */
+SIOPCB siopcb_table[TNUM_PORT];
+
+static const SIOPINIB siopinib_table[TNUM_SIOP] =
+{
+	{ P20, P21 },
+#if TNUM_SIOP > 1
+	{ P32, P33 },
+#endif
+#if TNUM_SIOP > 2
+	{ P50, P52 },
+#endif
+#if TNUM_SIOP > 3
+	{ P23, P25 },
+#endif
+#if TNUM_SIOP > 4
+	{ PC3, PC2 },
+#endif
+#if TNUM_SIOP > 5
+	{ PC7, PC6 },
+#endif
+#if TNUM_SIOP > 6
+	{ P26, P30 },
+#endif
+};
+
+/*
+ *  シリアルI/OポートIDから管理ブロックを取り出すためのマクロ
+ */
+#define INDEX_SIOP(siopid)	 ((uint_t)((siopid) - 1))
+#define get_siopcb(siopid)	 (&(siopcb_table[INDEX_SIOP(siopid)]))
+#define get_siopinib(siopid) (&(siopinib_table[INDEX_SIOP(siopid)]))
+
+static void mbed_serial_irq_handler(uint32_t id, SerialIrq event);
 
 /*
@@ -58,5 +116,14 @@
 sio_initialize(intptr_t exinf)
 {
-	rx630_uart_initialize();
+	SIOPCB	*p_siopcb;
+	uint_t	i;
+
+	/*
+	 *  シリアルI/Oポート管理ブロックの初期化
+	 */
+	for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
+		p_siopcb->p_siopinib = &(siopinib_table[i]);
+		p_siopcb->openflag = false;
+	}
 }
 
@@ -69,31 +136,23 @@
 	SIOPCB  *p_siopcb = NULL;
 	ER      ercd;
-	INTNO	intno_sio_tx, intno_sio_rx;
-	
-	/*
-	 *  シリアルI/O割込みをマスクする．
-	 *  (dis_int関数は、"\kernel\interrupt.c"に記述)
-	 */
-	p_siopcb = rx630_uart_get_siopcb(siopid);
-	intno_sio_tx = rx630_uart_intno_tx(p_siopcb);
-	intno_sio_rx = rx630_uart_intno_rx(p_siopcb);
-	ercd = dis_int(intno_sio_tx);
-	assert(ercd == E_OK);
-	ercd = dis_int(intno_sio_rx);
-	assert(ercd == E_OK);
-	
-	p_siopcb = 
-		rx630_uart_opn_por(siopid , exinf , UART_BAUDRATE , UART_CLKSRC);
-
-	/*
-	 *  シリアルI/O割込みをマスク解除する．
-	 *  (ena_int関数は、"\kernel\interrupt.c"に記述)
-	 */
-	ercd = ena_int(intno_sio_tx);
-	assert(ercd == E_OK);
-	ercd = ena_int(intno_sio_rx);
-	assert(ercd == E_OK);
-
-	return(p_siopcb);
+	serial_t *serial;
+
+	if ((siopid <= 0) || (siopid > (sizeof(siopcb_table) / sizeof(siopcb_table[0]))))
+		return NULL;
+	p_siopcb = get_siopcb(siopid);
+
+	if (p_siopcb->openflag)
+		return NULL;
+	p_siopcb->openflag = true;
+	p_siopcb->exinf = exinf;
+
+	serial = &p_siopcb->serial;
+	serial_init(serial, p_siopcb->p_siopinib->tx, p_siopcb->p_siopinib->rx);
+	serial_baud(serial, UART_BAUDRATE);
+	serial_format(serial, 8, ParityNone, 1);
+
+	serial_irq_handler(serial, mbed_serial_irq_handler, siopid);
+
+	return p_siopcb;
 }
 
@@ -105,20 +164,90 @@
 {
 	ER        ercd;
-	INTNO	intno_sio_tx, intno_sio_rx;
+	serial_t *serial = &p_siopcb->serial;
 
 	/*
 	 *  デバイス依存のクローズ処理．
 	 */
-	rx630_uart_cls_por(p_siopcb);
-	
-	/*
-	 *  シリアルI/O割込みをマスクする．
-	 */
-	intno_sio_tx = rx630_uart_intno_tx(p_siopcb);
-	intno_sio_rx = rx630_uart_intno_rx(p_siopcb);
-	ercd = dis_int(intno_sio_tx);
-	assert(ercd == E_OK);
-	ercd = dis_int(intno_sio_rx);
-	assert(ercd == E_OK);
+	serial_free(serial);
+	p_siopcb->openflag = false;
+}
+
+/*
+ *  シリアルI/Oポートへの文字送信
+ */
+bool_t
+sio_snd_chr(SIOPCB *p_siopcb, char c)
+{
+	serial_t *serial = &p_siopcb->serial;
+	if (!serial_writable(serial))
+		return false;
+	serial_putc(serial, c);
+	return true;
+}
+
+/*
+ *  シリアルI/Oポートからの文字受信
+ */
+int_t
+sio_rcv_chr(SIOPCB *p_siopcb)
+{
+	serial_t *serial = &p_siopcb->serial;
+	if (!serial_readable(serial))
+		return -1;
+	return serial_getc(serial);
+}
+
+/*
+ *  シリアルI/Oポートからのコールバックの許可
+ */
+void
+sio_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
+{
+	serial_t *serial = &p_siopcb->serial;
+	switch (cbrtn) {
+	case SIO_RDY_SND:
+		serial_irq_set(serial, TxIrq, true);
+		break;
+	case SIO_RDY_RCV:
+		serial_irq_set(serial, RxIrq, true);
+		break;
+	}
+}
+
+/*
+ *  シリアルI/Oポートからのコールバックの禁止
+ */
+void
+sio_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
+{
+	serial_t *serial = &p_siopcb->serial;
+	switch (cbrtn) {
+	case SIO_RDY_SND:
+		serial_irq_set(serial, TxIrq, false);
+		break;
+	case SIO_RDY_RCV:
+		serial_irq_set(serial, RxIrq, false);
+		break;
+	}
+}
+
+/*
+ *  シリアルI/Oポートからの送信可能コールバック
+ */
+void
+serial_irdy_snd(SIOPCB  *p_siopcb)
+{
+	/* 共通部（syssvc\serial.c）にあるsio_irdy_snd関数を呼び出し*/
+	sio_irdy_snd(p_siopcb->exinf);
+}
+
+/*
+ *  シリアルI/Oポートからの受信通知コールバック
+ */
+void
+serial_irdy_rcv(SIOPCB  *p_siopcb)
+{
+	/* 共通部（syssvc\serial.c）にあるsio_irdy_rcv関数を呼び出し*/
+	sio_irdy_rcv(p_siopcb->exinf);
 }
 
@@ -126,71 +255,23 @@
  *  SIOの割込みハンドラ
  */
-void sio_tx_isr(intptr_t exinf)
-{
-	rx630_uart_tx_isr(exinf);
-}
-
-/*
- *  SIOの割込みハンドラ
- */
-void sio_rx_isr(intptr_t exinf)
-{
-	rx630_uart_rx_isr(exinf);
-}
-
-/*
- *  シリアルI/Oポートへの文字送信
- */
-bool_t
-sio_snd_chr(SIOPCB *siopcb, char c)
-{
-	return(rx630_uart_snd_chr(siopcb, c));
-}
-
-/*
- *  シリアルI/Oポートからの文字受信
- */
-int_t
-sio_rcv_chr(SIOPCB *siopcb)
-{
-	return(rx630_uart_rcv_chr(siopcb));
-}
-
-/*
- *  シリアルI/Oポートからのコールバックの許可
- */
-void
-sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
-{
-	rx630_uart_ena_cbr(siopcb, cbrtn);
-}
-
-/*
- *  シリアルI/Oポートからのコールバックの禁止
- */
-void
-sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
-{
-	rx630_uart_dis_cbr(siopcb, cbrtn);
-}
-
-/*
- *  シリアルI/Oポートからの送信可能コールバック
- */
-void
-rx630_uart_irdy_snd(intptr_t exinf)
-{
-	/* 共通部（syssvc\serial.c）にあるsio_irdy_snd関数を呼び出し*/
-	sio_irdy_snd(exinf);
-}
-
-/*
- *  シリアルI/Oポートからの受信通知コールバック
- */
-void
-rx630_uart_irdy_rcv(intptr_t exinf)
-{
-	/* 共通部（syssvc\serial.c）にあるsio_irdy_rcv関数を呼び出し*/
-	sio_irdy_rcv(exinf);
-}
-
+void
+mbed_serial_irq_handler(uint32_t siopid, SerialIrq event)
+{
+	SIOPCB  *p_siopcb;
+
+	if ((siopid <= 0) || (siopid > (sizeof(siopcb_table) / sizeof(siopcb_table[0]))))
+		return;
+	p_siopcb = get_siopcb(siopid);
+
+	if (!p_siopcb->openflag)
+		return;
+
+	switch (event) {
+	case TxIrq:
+		serial_irdy_snd(p_siopcb);
+		break;
+	case RxIrq:
+		serial_irdy_rcv(p_siopcb);
+		break;
+	}
+}
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.cfg
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.cfg	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.cfg	(revision 374)
@@ -4,8 +4,5 @@
 
 #include <target_serial.h>
+
 ATT_INI({ TA_NULL, 0, sio_initialize });
-CFG_INT(INTNO_SIO_TX, { INTATR_SIO, INTPRI_SIO });
-CFG_INT(INTNO_SIO_RX, { INTATR_SIO, INTPRI_SIO });
 
-CRE_ISR(INTNO_SIO_TX_ISR, {TA_NULL, SIO_PORTID, INTNO_SIO_TX, sio_tx_isr, 1});
-CRE_ISR(INTNO_SIO_RX_ISR, {TA_NULL, SIO_PORTID, INTNO_SIO_RX, sio_rx_isr, 1});
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.h
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.h	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_serial.h	(revision 374)
@@ -53,18 +53,12 @@
 
 #include "gr_sakura.h"
-#include "rx630_uart.h"
+#include "serial_api.h"
 
-/*
- *  SIOの割込みハンドラのベクタ番号
- */
-#define INHNO_SIO_TX	INT_SCI0_TEI			/* 割込みハンドラ番号 */
-#define INTNO_SIO_TX	INT_SCI0_TEI			/* 割込み番号 */
-#define INHNO_SIO_RX	INT_SCI0_RXI			/* 割込みハンドラ番号 */
-#define INTNO_SIO_RX	INT_SCI0_RXI			/* 割込み番号 */
-#define INTPRI_SIO		-4						/* 割込み優先度 */
-#define INTATR_SIO		(TA_NULL)				/* 割込み属性 */
+#define SIO_RDY_SND 1
+#define SIO_RDY_RCV 2
 
 #ifndef TOPPERS_MACRO_ONLY
 
+typedef struct sio_port_control_block SIOPCB;
 
 /*
@@ -82,10 +76,4 @@
  */
 extern void		sio_cls_por(SIOPCB *p_siopcb);
-
-/*
- *  SIOの割込みハンドラ
- */
-extern void 	sio_tx_isr(intptr_t exinf);
-extern void 	sio_rx_isr(intptr_t exinf);
 
 /*
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_syssvc.h
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_syssvc.h	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/target/gr_sakura_gcc/target_syssvc.h	(revision 374)
@@ -113,4 +113,10 @@
 
 /*
+ *  使用するシリアルポートのPinName
+ */
+#define STDIO_UART_TX P20
+#define STDIO_UART_RX P21
+
+/*
  *  システムログタスク関連の定数の定義
  *
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_for_asp3
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_for_asp3	(revision 374)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_for_asp3	(revision 374)
@@ -0,0 +1,106 @@
+MANIFEST_for_asp3
+
+tecsgen
+tecsgen.rb
+tecsmerge
+tecsmerge.rb
+
+tecslib/version.rb
+
+tecslib/core/C_parser.tab.rb
+tecslib/core/C_parser.y.rb
+tecslib/core/bnf.tab.rb
+tecslib/core/bnf.y.rb
+tecslib/core/componentobj.rb
+tecslib/core/ctypes.rb
+tecslib/core/expression.rb
+tecslib/core/gen_xml.rb
+tecslib/core/generate.rb
+tecslib/core/location.rb
+tecslib/core/messages.rb
+tecslib/core/optimize.rb
+tecslib/core/plugin.rb
+tecslib/core/pluginModule.rb
+tecslib/core/syntaxobj.rb
+tecslib/core/tecs_lang.rb
+tecslib/core/tecsgen.rb
+tecslib/core/tecsinfo.rb
+tecslib/core/tool_info.rb
+tecslib/core/types.rb
+tecslib/core/unjoin_plugin.rb
+tecslib/core/value.rb
+
+tecslib/messages/messages_console_en_US.rb
+tecslib/messages/messages_console_ja_JP.rb
+tecslib/messages/messages_file_en_US.rb
+tecslib/messages/messages_file_ja_JP.rb
+
+tecslib/plugin/C2TECSBridgePlugin.rb
+tecslib/plugin/CellPlugin.rb
+tecslib/plugin/CelltypePlugin.rb
+tecslib/plugin/CompositePlugin.rb
+tecslib/plugin/DomainPlugin.rb
+tecslib/plugin/Mruby2CBridgePlugin.rb
+tecslib/plugin/MrubyBridgePlugin.rb
+tecslib/plugin/MultiPlugin.rb
+tecslib/plugin/NotifierPlugin.rb
+tecslib/plugin/RPCPlugin.rb
+tecslib/plugin/SignaturePlugin.rb
+tecslib/plugin/TECS2CBridgePlugin.rb
+tecslib/plugin/ThroughPlugin.rb
+tecslib/plugin/TracePlugin.rb
+tecslib/plugin/lib/GenParamCopy.rb
+tecslib/plugin/lib/GenTransparentMarshaler.rb
+
+tecs/tecs.h
+tecs/tecs.xsd
+
+tecs/mruby/TECSPointer.h
+tecs/mruby/TECSStruct.h
+tecs/mruby/mruby.cdl
+tecs/mruby/mrubyInitializer.cdl
+tecs/mruby/mrubyPointers.cdl
+tecs/mruby/mrubyVMs.cdl
+tecs/mruby/nMruby_tBoolPointer.c
+tecs/mruby/nMruby_tCharPointer.c
+tecs/mruby/nMruby_tDouble64Pointer.c
+tecs/mruby/nMruby_tFloat32Pointer.c
+tecs/mruby/nMruby_tInt16Pointer.c
+tecs/mruby/nMruby_tInt32Pointer.c
+tecs/mruby/nMruby_tInt64Pointer.c
+tecs/mruby/nMruby_tInt8Pointer.c
+tecs/mruby/nMruby_tIntPointer.c
+tecs/mruby/nMruby_tLongPointer.c
+tecs/mruby/nMruby_tMruby.c
+tecs/mruby/nMruby_tSCharPointer.c
+tecs/mruby/nMruby_tShortPointer.c
+tecs/mruby/nMruby_tTECSInitializer.c
+tecs/mruby/nMruby_tUCharPointer.c
+tecs/mruby/nMruby_tUInt16Pointer.c
+tecs/mruby/nMruby_tUInt32Pointer.c
+tecs/mruby/nMruby_tUInt64Pointer.c
+tecs/mruby/nMruby_tUInt8Pointer.c
+tecs/mruby/nMruby_tUIntPointer.c
+tecs/mruby/nMruby_tULongPointer.c
+tecs/mruby/nMruby_tUShortPointer.c
+tecs/mruby/tMruby.cdl
+tecs/mruby/tecs_mruby.h
+
+tecs/posix/posix.cdl
+
+tecs/rpc/PPAllocator.cdl
+tecs/rpc/RPCTask.cdl
+tecs/rpc/TDR.cdl
+tecs/rpc/rpc.cdl
+tecs/rpc/rpc_string.h
+tecs/rpc/sChannel.cdl
+tecs/rpc/sRPCErrorHandler.cdl
+tecs/rpc/tDataqueueAdaptor_inline.h
+tecs/rpc/tDataqueueOWChannel.cdl
+tecs/rpc/tPPAllocator.c
+tecs/rpc/tRPCDedicatedTaskMain.c
+tecs/rpc/tTDR_inline.h
+tecs/rpc/tecs_rpc.h
+tecs/rpc/tMessageBufferCEP.cdl
+tecs/rpc/tMessageBufferCEP_inline.h
+tecs/rpc/tMessageBufferChannel.cdl
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_tecsgen_body
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_tecsgen_body	(revision 364)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/MANIFEST_tecsgen_body	(revision 374)
@@ -1,5 +1,12 @@
 MANIFEST_tecsgen_body
+
 Makefile
-
+tecscde
+tecscde.rb
+tecsgen
+tecsgen.rb
+tecsgen_rcov.rb
+tecsmerge
+tecsmerge.rb
 cdelib/Makefile
 cdelib/cell_plugin_dialog.rb
@@ -11,8 +18,7 @@
 cdelib/tview.rb
 cdelib/version.rb
-
 tecs/TECSInfo/TECSInfo.cdl
+tecs/TECSInfo/TECSInfoAccessor.cdl
 tecs/TECSInfo/nTECSInfo_tArrayTypeInfo.c
-tecs/TECSInfo/nTECSInfo_tAttrVarInfo.c
 tecs/TECSInfo/nTECSInfo_tBoolTypeInfo.c
 tecs/TECSInfo/nTECSInfo_tCallInfo.c
@@ -28,7 +34,9 @@
 tecs/TECSInfo/nTECSInfo_tParamInfo.c
 tecs/TECSInfo/nTECSInfo_tPtrTypeInfo.c
+tecs/TECSInfo/nTECSInfo_tRawEntryDescriptorInfo.c
 tecs/TECSInfo/nTECSInfo_tRegionInfo.c
 tecs/TECSInfo/nTECSInfo_tSignatureInfo.c
 tecs/TECSInfo/nTECSInfo_tStructTypeInfo.c
+tecs/TECSInfo/nTECSInfo_tTECSInfoAccessor.c
 tecs/TECSInfo/nTECSInfo_tTECSInfoSub.c
 tecs/TECSInfo/nTECSInfo_tTECSInfo_inline.h
@@ -36,4 +44,5 @@
 tecs/TECSInfo/nTECSInfo_tVarDeclInfo.c
 tecs/TECSInfo/nTECSInfo_tVoidTypeInfo.c
+tecs/TECSInfo/tTECSInfoAccessor.c
 tecs/TLSFMalloc/README-TLSF.txt
 tecs/TLSFMalloc/tTLSFMalloc.cdl
@@ -61,4 +70,5 @@
 tecs/mruby/nMruby_tMruby.c
 tecs/mruby/nMruby_tMrubyCyclicTaskBody.c
+tecs/mruby/nMruby_tMrubyProc.c
 tecs/mruby/nMruby_tMrubyTaskBody.c
 tecs/mruby/nMruby_tMrubyVM.c
@@ -87,4 +97,7 @@
 tecs/rpc/tDataqueueAdaptor_inline.h
 tecs/rpc/tDataqueueOWChannel.cdl
+tecs/rpc/tMessageBufferCEP.cdl
+tecs/rpc/tMessageBufferCEP_inline.h
+tecs/rpc/tMessageBufferChannel.cdl
 tecs/rpc/tNBOTDR_inline.h
 tecs/rpc/tPPAllocator.c
@@ -105,11 +118,4 @@
 tecs/tecs.h
 tecs/tecs.xsd
-
-tecscde
-tecscde.rb
-tecsgen
-tecsgen.rb
-tecsgen_rcov
-tecsgen_rcov.rb
 tecslib/core/C_parser.tab.rb
 tecslib/core/C_parser.y.rb
@@ -132,4 +138,5 @@
 tecslib/core/tool_info.rb
 tecslib/core/types.rb
+tecslib/core/unjoin_plugin.rb
 tecslib/core/value.rb
 tecslib/messages/messages_console_en_US.rb
@@ -165,7 +172,16 @@
 tecslib/plugin/HRP2SemaphorePlugin.rb
 tecslib/plugin/HRP2TaskPlugin.rb
+tecslib/plugin/HRPHandlerPlugin.rb
+tecslib/plugin/HRPKernelObjectManager.rb
+tecslib/plugin/HRPKernelObjectPlugin.rb
+tecslib/plugin/HRPObjectPlugin.rb
+tecslib/plugin/HRPPlugin.rb
+tecslib/plugin/HRPRPCPlugin.rb
+tecslib/plugin/HRPSVCPlugin.rb
+tecslib/plugin/HRPTaskPlugin.rb
 tecslib/plugin/Mruby2CBridgePlugin.rb
 tecslib/plugin/MrubyBridgeCellPlugin.rb
 tecslib/plugin/MrubyBridgeCelltypePlugin.rb
+tecslib/plugin/MrubyBridgeCompositePlugin.rb
 tecslib/plugin/MrubyBridgePlugin.rb
 tecslib/plugin/MrubyBridgeSignaturePlugin.rb
@@ -175,4 +191,6 @@
 tecslib/plugin/OpaqueRPCPlugin.rb
 tecslib/plugin/RPCPlugin.rb
+tecslib/plugin/RepeatCellPlugin.rb
+tecslib/plugin/RepeatJoinPlugin.rb
 tecslib/plugin/SharedOpaqueRPCPlugin.rb
 tecslib/plugin/SharedRPCPlugin.rb
@@ -186,6 +204,4 @@
 tecslib/plugin/lib/GenParamCopy.rb
 tecslib/plugin/lib/GenTransparentMarshaler.rb
+tecslib/plugin/lib/MrubyBridgeCelltypePluginModule.rb
 tecslib/version.rb
-
-tecsmerge
-tecsmerge.rb
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/in_exerb.rb
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/in_exerb.rb	(revision 374)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tecsgen/in_exerb.rb	(revision 374)
@@ -0,0 +1,114 @@
+# coding: utf-8
+#
+#  TECS Generator
+#      Generator for TOPPERS Embedded Component System
+#  
+#   Copyright (C) 2008-2015 by TOPPERS Project
+#--
+#   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+#   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+#   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+#   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+#       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+#       スコード中に含まれていること．
+#   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+#       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+#       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+#       の無保証規定を掲載すること．
+#   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+#       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+#       と．
+#     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+#         作権表示，この利用条件および下記の無保証規定を掲載すること．
+#     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+#         報告すること．
+#   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+#       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+#       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+#       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+#       免責すること．
+#  
+#   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+#   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+#   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+#   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+#   の責任を負わない．
+#  
+#   $Id$
+#++
+
+# exerb 版で最初に読みこまれるファイル
+# このファイルから generate.rb が読みこまれる
+
+$IN_EXERB=true
+
+# この変数は exerb 版のみ
+$path = ENV[ 'PATH' ]
+
+#=== cygwin のパスを Windows パスに変換
+# cygpath コマンドを探して、見つかれば変換する
+# 変換できなかった、または変換後のパスが見つからない場合、default を返す
+def cygpath( path, default = nil )
+  if ! $IN_EXERB then
+    return default
+  end
+  if File.exist? path then
+    return default
+  end
+
+  found = false
+  $path.split( ";" ).each{ |path2|
+    cygpath_path = "#{path2}\\cygpath.exe"
+    if File.exist?( cygpath_path )  then
+      path3 = nil
+      dbgPrint "in_exerb: cygpath: found\n"
+      IO.popen( "cygpath -m #{path}", "r"){ |io|
+        path3 = io.gets.chomp!
+      }
+      dbgPrint "in_exerb: cygpath: '#{path}' => '#{path3}'\n"
+      # File.stat( path3.to_s )
+
+      if File.exist?( path3 )
+        dbgPrint "in_exerb: cygpath: '#{path3}' found\n"
+        return path3
+      else
+        break
+      end
+    end
+  }
+  dbgPrint "cygpath '#{path}' not found\n"
+  return default
+end
+
+# gcc のパスを設定する
+#  cygwin のあるバージョンでは gcc は gcc-3.exe または gcc-4.exe へのシンボリックリンクとなっている
+#  exerb 版ではシンボリックリンクを辿れないため gcc の exe を探す
+#  cygwin のリンクは、システム属性が付けられ、コマンドプロンプト上では dir /A:S を指定しないと表示されない
+#  (cygwin のバージョンで実装が異なるかもしれない)
+#  ファイルの先頭2バイトを読出し PE フォーマットのマジックに一致するか調べる
+$gcc = "gcc"
+$path.split( ";" ).each{ |path|
+  found = false
+  [ "gcc.exe", "gcc-3.exe", "gcc-4.exe" ].each{ |gcc|
+    gcc_path = "#{path}\\#{gcc}"
+    if File.exist?( gcc_path )  then
+      begin
+        magic = File.read( gcc_path, 2 )
+        if magic == "MZ"                  # マジックをチェック
+          $gcc = gcc
+          found = true
+          break
+        end
+      rescue
+        # magic の読出しに失敗。無視
+      end
+    end
+  }
+  break if found
+}
+
+# cpp コマンドを設定する
+$cpp = "#{$gcc} -E -D TECSGEN"
+
+# exerb 版 TECS ジェネレータの実行を開始
+require "tecsgen.rb"
